diff -ruBEN trunk/configure.ac SQUID_3_2/configure.ac
--- trunk/configure.ac	2011-03-13 22:54:56.000000000 +0000
+++ SQUID_3_2/configure.ac	2011-03-13 22:59:01.000000000 +0000
@@ -3418,6 +3418,7 @@
 	helpers/ntlm_auth/smb_lm/Makefile \
 	helpers/ntlm_auth/SSPI/Makefile \
 	helpers/negotiate_auth/Makefile \
+	helpers/negotiate_auth/negotiate_wrapper/Makefile \
 	helpers/negotiate_auth/kerberos/Makefile \
 	helpers/negotiate_auth/SSPI/Makefile \
 	helpers/external_acl/Makefile \
diff -ruBEN trunk/helpers/negotiate_auth/Makefile.am SQUID_3_2/helpers/negotiate_auth/Makefile.am
--- trunk/helpers/negotiate_auth/Makefile.am	2011-03-13 22:54:56.000000000 +0000
+++ SQUID_3_2/helpers/negotiate_auth/Makefile.am	2011-03-13 22:59:01.000000000 +0000
@@ -1,3 +1,3 @@
 
-DIST_SUBDIRS	= kerberos SSPI
+DIST_SUBDIRS	= kerberos SSPI negotiate_wrapper
 SUBDIRS		= $(NEGOTIATE_AUTH_HELPERS)
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/base64.cc SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/base64.cc
--- trunk/helpers/negotiate_auth/negotiate_wrapper/base64.cc	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/base64.cc	2011-03-13 18:47:37.000000000 +0000
@@ -0,0 +1,83 @@
+/*
+ * Markus Moeller has modified the following code from Squid
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include "base64.h"
+
+
+static void nw_base64_init(void);
+
+static int base64_initialized = 0;
+#define BASE64_VALUE_SZ 256
+int base64_value[BASE64_VALUE_SZ];
+const char base64_code[] =
+"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
+
+
+static void
+nw_base64_init(void)
+{
+    int i;
+
+    for (i = 0; i < BASE64_VALUE_SZ; i++)
+	base64_value[i] = -1;
+
+    for (i = 0; i < 64; i++)
+	base64_value[(int) base64_code[i]] = i;
+    base64_value['='] = 0;
+
+    base64_initialized = 1;
+}
+
+void
+nw_base64_decode(char *result, const char *data, int result_size)
+{
+    int j;
+    int c;
+    long val;
+    if (!data)
+	return;
+    if (!base64_initialized)
+	nw_base64_init();
+    val = c = 0;
+
+    for (j = 0; *data; data++) {
+	unsigned int k = ((unsigned char) *data) % BASE64_VALUE_SZ;
+	if (base64_value[k] < 0)
+	    continue;
+	val <<= 6;
+	val += base64_value[k];
+	if (++c < 4)
+	    continue;
+	/* One quantum of four encoding characters/24 bit */
+	if (j >= result_size)
+	    break;
+	result[j++] = val >> 16;	/* High 8 bits */
+	if (j >= result_size)
+	    break;
+	result[j++] = (val >> 8) & 0xff;	/* Mid 8 bits */
+	if (j >= result_size)
+	    break;
+	result[j++] = val & 0xff;	/* Low 8 bits */
+	val = c = 0;
+    }
+    return;
+}
+
+int
+nw_base64_decode_len(const char *data)
+{
+    int i, j;
+
+    j = 0;
+    for (i = strlen(data) - 1; i >= 0; i--) {
+	if (data[i] == '=')
+	    j++;
+	if (data[i] != '=')
+	    break;
+    }
+    return strlen(data) / 4 * 3 - j;
+}
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/base64.h SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/base64.h
--- trunk/helpers/negotiate_auth/negotiate_wrapper/base64.h	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/base64.h	2011-03-13 18:47:37.000000000 +0000
@@ -0,0 +1,7 @@
+
+/*
+ * Markus Moeller has modified the following code from Squid
+ */
+
+void nw_base64_decode(char *result, const char *data, int result_size);
+int nw_base64_decode_len(const char *data);
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/config.test SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/config.test
--- trunk/helpers/negotiate_auth/negotiate_wrapper/config.test	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/config.test	2011-03-13 22:24:55.000000000 +0000
@@ -0,0 +1,2 @@
+#!/bin/sh
+exit 0
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/COPYING SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/COPYING
--- trunk/helpers/negotiate_auth/negotiate_wrapper/COPYING	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/COPYING	2011-03-13 18:24:32.000000000 +0000
@@ -0,0 +1,674 @@
+                    GNU GENERAL PUBLIC LICENSE
+                       Version 3, 29 June 2007
+
+ Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+                            Preamble
+
+  The GNU General Public License is a free, copyleft license for
+software and other kinds of works.
+
+  The licenses for most software and other practical works are designed
+to take away your freedom to share and change the works.  By contrast,
+the GNU General Public License is intended to guarantee your freedom to
+share and change all versions of a program--to make sure it remains free
+software for all its users.  We, the Free Software Foundation, use the
+GNU General Public License for most of our software; it applies also to
+any other work released this way by its authors.  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+them if you wish), that you receive source code or can get it if you
+want it, that you can change the software or use pieces of it in new
+free programs, and that you know you can do these things.
+
+  To protect your rights, we need to prevent others from denying you
+these rights or asking you to surrender the rights.  Therefore, you have
+certain responsibilities if you distribute copies of the software, or if
+you modify it: responsibilities to respect the freedom of others.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must pass on to the recipients the same
+freedoms that you received.  You must make sure that they, too, receive
+or can get the source code.  And you must show them these terms so they
+know their rights.
+
+  Developers that use the GNU GPL protect your rights with two steps:
+(1) assert copyright on the software, and (2) offer you this License
+giving you legal permission to copy, distribute and/or modify it.
+
+  For the developers' and authors' protection, the GPL clearly explains
+that there is no warranty for this free software.  For both users' and
+authors' sake, the GPL requires that modified versions be marked as
+changed, so that their problems will not be attributed erroneously to
+authors of previous versions.
+
+  Some devices are designed to deny users access to install or run
+modified versions of the software inside them, although the manufacturer
+can do so.  This is fundamentally incompatible with the aim of
+protecting users' freedom to change the software.  The systematic
+pattern of such abuse occurs in the area of products for individuals to
+use, which is precisely where it is most unacceptable.  Therefore, we
+have designed this version of the GPL to prohibit the practice for those
+products.  If such problems arise substantially in other domains, we
+stand ready to extend this provision to those domains in future versions
+of the GPL, as needed to protect the freedom of users.
+
+  Finally, every program is threatened constantly by software patents.
+States should not allow patents to restrict development and use of
+software on general-purpose computers, but in those that do, we wish to
+avoid the special danger that patents applied to a free program could
+make it effectively proprietary.  To prevent this, the GPL assures that
+patents cannot be used to render the program non-free.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+                       TERMS AND CONDITIONS
+
+  0. Definitions.
+
+  "This License" refers to version 3 of the GNU General Public License.
+
+  "Copyright" also means copyright-like laws that apply to other kinds of
+works, such as semiconductor masks.
+
+  "The Program" refers to any copyrightable work licensed under this
+License.  Each licensee is addressed as "you".  "Licensees" and
+"recipients" may be individuals or organizations.
+
+  To "modify" a work means to copy from or adapt all or part of the work
+in a fashion requiring copyright permission, other than the making of an
+exact copy.  The resulting work is called a "modified version" of the
+earlier work or a work "based on" the earlier work.
+
+  A "covered work" means either the unmodified Program or a work based
+on the Program.
+
+  To "propagate" a work means to do anything with it that, without
+permission, would make you directly or secondarily liable for
+infringement under applicable copyright law, except executing it on a
+computer or modifying a private copy.  Propagation includes copying,
+distribution (with or without modification), making available to the
+public, and in some countries other activities as well.
+
+  To "convey" a work means any kind of propagation that enables other
+parties to make or receive copies.  Mere interaction with a user through
+a computer network, with no transfer of a copy, is not conveying.
+
+  An interactive user interface displays "Appropriate Legal Notices"
+to the extent that it includes a convenient and prominently visible
+feature that (1) displays an appropriate copyright notice, and (2)
+tells the user that there is no warranty for the work (except to the
+extent that warranties are provided), that licensees may convey the
+work under this License, and how to view a copy of this License.  If
+the interface presents a list of user commands or options, such as a
+menu, a prominent item in the list meets this criterion.
+
+  1. Source Code.
+
+  The "source code" for a work means the preferred form of the work
+for making modifications to it.  "Object code" means any non-source
+form of a work.
+
+  A "Standard Interface" means an interface that either is an official
+standard defined by a recognized standards body, or, in the case of
+interfaces specified for a particular programming language, one that
+is widely used among developers working in that language.
+
+  The "System Libraries" of an executable work include anything, other
+than the work as a whole, that (a) is included in the normal form of
+packaging a Major Component, but which is not part of that Major
+Component, and (b) serves only to enable use of the work with that
+Major Component, or to implement a Standard Interface for which an
+implementation is available to the public in source code form.  A
+"Major Component", in this context, means a major essential component
+(kernel, window system, and so on) of the specific operating system
+(if any) on which the executable work runs, or a compiler used to
+produce the work, or an object code interpreter used to run it.
+
+  The "Corresponding Source" for a work in object code form means all
+the source code needed to generate, install, and (for an executable
+work) run the object code and to modify the work, including scripts to
+control those activities.  However, it does not include the work's
+System Libraries, or general-purpose tools or generally available free
+programs which are used unmodified in performing those activities but
+which are not part of the work.  For example, Corresponding Source
+includes interface definition files associated with source files for
+the work, and the source code for shared libraries and dynamically
+linked subprograms that the work is specifically designed to require,
+such as by intimate data communication or control flow between those
+subprograms and other parts of the work.
+
+  The Corresponding Source need not include anything that users
+can regenerate automatically from other parts of the Corresponding
+Source.
+
+  The Corresponding Source for a work in source code form is that
+same work.
+
+  2. Basic Permissions.
+
+  All rights granted under this License are granted for the term of
+copyright on the Program, and are irrevocable provided the stated
+conditions are met.  This License explicitly affirms your unlimited
+permission to run the unmodified Program.  The output from running a
+covered work is covered by this License only if the output, given its
+content, constitutes a covered work.  This License acknowledges your
+rights of fair use or other equivalent, as provided by copyright law.
+
+  You may make, run and propagate covered works that you do not
+convey, without conditions so long as your license otherwise remains
+in force.  You may convey covered works to others for the sole purpose
+of having them make modifications exclusively for you, or provide you
+with facilities for running those works, provided that you comply with
+the terms of this License in conveying all material for which you do
+not control copyright.  Those thus making or running the covered works
+for you must do so exclusively on your behalf, under your direction
+and control, on terms that prohibit them from making any copies of
+your copyrighted material outside their relationship with you.
+
+  Conveying under any other circumstances is permitted solely under
+the conditions stated below.  Sublicensing is not allowed; section 10
+makes it unnecessary.
+
+  3. Protecting Users' Legal Rights From Anti-Circumvention Law.
+
+  No covered work shall be deemed part of an effective technological
+measure under any applicable law fulfilling obligations under article
+11 of the WIPO copyright treaty adopted on 20 December 1996, or
+similar laws prohibiting or restricting circumvention of such
+measures.
+
+  When you convey a covered work, you waive any legal power to forbid
+circumvention of technological measures to the extent such circumvention
+is effected by exercising rights under this License with respect to
+the covered work, and you disclaim any intention to limit operation or
+modification of the work as a means of enforcing, against the work's
+users, your or third parties' legal rights to forbid circumvention of
+technological measures.
+
+  4. Conveying Verbatim Copies.
+
+  You may convey verbatim copies of the Program's source code as you
+receive it, in any medium, provided that you conspicuously and
+appropriately publish on each copy an appropriate copyright notice;
+keep intact all notices stating that this License and any
+non-permissive terms added in accord with section 7 apply to the code;
+keep intact all notices of the absence of any warranty; and give all
+recipients a copy of this License along with the Program.
+
+  You may charge any price or no price for each copy that you convey,
+and you may offer support or warranty protection for a fee.
+
+  5. Conveying Modified Source Versions.
+
+  You may convey a work based on the Program, or the modifications to
+produce it from the Program, in the form of source code under the
+terms of section 4, provided that you also meet all of these conditions:
+
+    a) The work must carry prominent notices stating that you modified
+    it, and giving a relevant date.
+
+    b) The work must carry prominent notices stating that it is
+    released under this License and any conditions added under section
+    7.  This requirement modifies the requirement in section 4 to
+    "keep intact all notices".
+
+    c) You must license the entire work, as a whole, under this
+    License to anyone who comes into possession of a copy.  This
+    License will therefore apply, along with any applicable section 7
+    additional terms, to the whole of the work, and all its parts,
+    regardless of how they are packaged.  This License gives no
+    permission to license the work in any other way, but it does not
+    invalidate such permission if you have separately received it.
+
+    d) If the work has interactive user interfaces, each must display
+    Appropriate Legal Notices; however, if the Program has interactive
+    interfaces that do not display Appropriate Legal Notices, your
+    work need not make them do so.
+
+  A compilation of a covered work with other separate and independent
+works, which are not by their nature extensions of the covered work,
+and which are not combined with it such as to form a larger program,
+in or on a volume of a storage or distribution medium, is called an
+"aggregate" if the compilation and its resulting copyright are not
+used to limit the access or legal rights of the compilation's users
+beyond what the individual works permit.  Inclusion of a covered work
+in an aggregate does not cause this License to apply to the other
+parts of the aggregate.
+
+  6. Conveying Non-Source Forms.
+
+  You may convey a covered work in object code form under the terms
+of sections 4 and 5, provided that you also convey the
+machine-readable Corresponding Source under the terms of this License,
+in one of these ways:
+
+    a) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by the
+    Corresponding Source fixed on a durable physical medium
+    customarily used for software interchange.
+
+    b) Convey the object code in, or embodied in, a physical product
+    (including a physical distribution medium), accompanied by a
+    written offer, valid for at least three years and valid for as
+    long as you offer spare parts or customer support for that product
+    model, to give anyone who possesses the object code either (1) a
+    copy of the Corresponding Source for all the software in the
+    product that is covered by this License, on a durable physical
+    medium customarily used for software interchange, for a price no
+    more than your reasonable cost of physically performing this
+    conveying of source, or (2) access to copy the
+    Corresponding Source from a network server at no charge.
+
+    c) Convey individual copies of the object code with a copy of the
+    written offer to provide the Corresponding Source.  This
+    alternative is allowed only occasionally and noncommercially, and
+    only if you received the object code with such an offer, in accord
+    with subsection 6b.
+
+    d) Convey the object code by offering access from a designated
+    place (gratis or for a charge), and offer equivalent access to the
+    Corresponding Source in the same way through the same place at no
+    further charge.  You need not require recipients to copy the
+    Corresponding Source along with the object code.  If the place to
+    copy the object code is a network server, the Corresponding Source
+    may be on a different server (operated by you or a third party)
+    that supports equivalent copying facilities, provided you maintain
+    clear directions next to the object code saying where to find the
+    Corresponding Source.  Regardless of what server hosts the
+    Corresponding Source, you remain obligated to ensure that it is
+    available for as long as needed to satisfy these requirements.
+
+    e) Convey the object code using peer-to-peer transmission, provided
+    you inform other peers where the object code and Corresponding
+    Source of the work are being offered to the general public at no
+    charge under subsection 6d.
+
+  A separable portion of the object code, whose source code is excluded
+from the Corresponding Source as a System Library, need not be
+included in conveying the object code work.
+
+  A "User Product" is either (1) a "consumer product", which means any
+tangible personal property which is normally used for personal, family,
+or household purposes, or (2) anything designed or sold for incorporation
+into a dwelling.  In determining whether a product is a consumer product,
+doubtful cases shall be resolved in favor of coverage.  For a particular
+product received by a particular user, "normally used" refers to a
+typical or common use of that class of product, regardless of the status
+of the particular user or of the way in which the particular user
+actually uses, or expects or is expected to use, the product.  A product
+is a consumer product regardless of whether the product has substantial
+commercial, industrial or non-consumer uses, unless such uses represent
+the only significant mode of use of the product.
+
+  "Installation Information" for a User Product means any methods,
+procedures, authorization keys, or other information required to install
+and execute modified versions of a covered work in that User Product from
+a modified version of its Corresponding Source.  The information must
+suffice to ensure that the continued functioning of the modified object
+code is in no case prevented or interfered with solely because
+modification has been made.
+
+  If you convey an object code work under this section in, or with, or
+specifically for use in, a User Product, and the conveying occurs as
+part of a transaction in which the right of possession and use of the
+User Product is transferred to the recipient in perpetuity or for a
+fixed term (regardless of how the transaction is characterized), the
+Corresponding Source conveyed under this section must be accompanied
+by the Installation Information.  But this requirement does not apply
+if neither you nor any third party retains the ability to install
+modified object code on the User Product (for example, the work has
+been installed in ROM).
+
+  The requirement to provide Installation Information does not include a
+requirement to continue to provide support service, warranty, or updates
+for a work that has been modified or installed by the recipient, or for
+the User Product in which it has been modified or installed.  Access to a
+network may be denied when the modification itself materially and
+adversely affects the operation of the network or violates the rules and
+protocols for communication across the network.
+
+  Corresponding Source conveyed, and Installation Information provided,
+in accord with this section must be in a format that is publicly
+documented (and with an implementation available to the public in
+source code form), and must require no special password or key for
+unpacking, reading or copying.
+
+  7. Additional Terms.
+
+  "Additional permissions" are terms that supplement the terms of this
+License by making exceptions from one or more of its conditions.
+Additional permissions that are applicable to the entire Program shall
+be treated as though they were included in this License, to the extent
+that they are valid under applicable law.  If additional permissions
+apply only to part of the Program, that part may be used separately
+under those permissions, but the entire Program remains governed by
+this License without regard to the additional permissions.
+
+  When you convey a copy of a covered work, you may at your option
+remove any additional permissions from that copy, or from any part of
+it.  (Additional permissions may be written to require their own
+removal in certain cases when you modify the work.)  You may place
+additional permissions on material, added by you to a covered work,
+for which you have or can give appropriate copyright permission.
+
+  Notwithstanding any other provision of this License, for material you
+add to a covered work, you may (if authorized by the copyright holders of
+that material) supplement the terms of this License with terms:
+
+    a) Disclaiming warranty or limiting liability differently from the
+    terms of sections 15 and 16 of this License; or
+
+    b) Requiring preservation of specified reasonable legal notices or
+    author attributions in that material or in the Appropriate Legal
+    Notices displayed by works containing it; or
+
+    c) Prohibiting misrepresentation of the origin of that material, or
+    requiring that modified versions of such material be marked in
+    reasonable ways as different from the original version; or
+
+    d) Limiting the use for publicity purposes of names of licensors or
+    authors of the material; or
+
+    e) Declining to grant rights under trademark law for use of some
+    trade names, trademarks, or service marks; or
+
+    f) Requiring indemnification of licensors and authors of that
+    material by anyone who conveys the material (or modified versions of
+    it) with contractual assumptions of liability to the recipient, for
+    any liability that these contractual assumptions directly impose on
+    those licensors and authors.
+
+  All other non-permissive additional terms are considered "further
+restrictions" within the meaning of section 10.  If the Program as you
+received it, or any part of it, contains a notice stating that it is
+governed by this License along with a term that is a further
+restriction, you may remove that term.  If a license document contains
+a further restriction but permits relicensing or conveying under this
+License, you may add to a covered work material governed by the terms
+of that license document, provided that the further restriction does
+not survive such relicensing or conveying.
+
+  If you add terms to a covered work in accord with this section, you
+must place, in the relevant source files, a statement of the
+additional terms that apply to those files, or a notice indicating
+where to find the applicable terms.
+
+  Additional terms, permissive or non-permissive, may be stated in the
+form of a separately written license, or stated as exceptions;
+the above requirements apply either way.
+
+  8. Termination.
+
+  You may not propagate or modify a covered work except as expressly
+provided under this License.  Any attempt otherwise to propagate or
+modify it is void, and will automatically terminate your rights under
+this License (including any patent licenses granted under the third
+paragraph of section 11).
+
+  However, if you cease all violation of this License, then your
+license from a particular copyright holder is reinstated (a)
+provisionally, unless and until the copyright holder explicitly and
+finally terminates your license, and (b) permanently, if the copyright
+holder fails to notify you of the violation by some reasonable means
+prior to 60 days after the cessation.
+
+  Moreover, your license from a particular copyright holder is
+reinstated permanently if the copyright holder notifies you of the
+violation by some reasonable means, this is the first time you have
+received notice of violation of this License (for any work) from that
+copyright holder, and you cure the violation prior to 30 days after
+your receipt of the notice.
+
+  Termination of your rights under this section does not terminate the
+licenses of parties who have received copies or rights from you under
+this License.  If your rights have been terminated and not permanently
+reinstated, you do not qualify to receive new licenses for the same
+material under section 10.
+
+  9. Acceptance Not Required for Having Copies.
+
+  You are not required to accept this License in order to receive or
+run a copy of the Program.  Ancillary propagation of a covered work
+occurring solely as a consequence of using peer-to-peer transmission
+to receive a copy likewise does not require acceptance.  However,
+nothing other than this License grants you permission to propagate or
+modify any covered work.  These actions infringe copyright if you do
+not accept this License.  Therefore, by modifying or propagating a
+covered work, you indicate your acceptance of this License to do so.
+
+  10. Automatic Licensing of Downstream Recipients.
+
+  Each time you convey a covered work, the recipient automatically
+receives a license from the original licensors, to run, modify and
+propagate that work, subject to this License.  You are not responsible
+for enforcing compliance by third parties with this License.
+
+  An "entity transaction" is a transaction transferring control of an
+organization, or substantially all assets of one, or subdividing an
+organization, or merging organizations.  If propagation of a covered
+work results from an entity transaction, each party to that
+transaction who receives a copy of the work also receives whatever
+licenses to the work the party's predecessor in interest had or could
+give under the previous paragraph, plus a right to possession of the
+Corresponding Source of the work from the predecessor in interest, if
+the predecessor has it or can get it with reasonable efforts.
+
+  You may not impose any further restrictions on the exercise of the
+rights granted or affirmed under this License.  For example, you may
+not impose a license fee, royalty, or other charge for exercise of
+rights granted under this License, and you may not initiate litigation
+(including a cross-claim or counterclaim in a lawsuit) alleging that
+any patent claim is infringed by making, using, selling, offering for
+sale, or importing the Program or any portion of it.
+
+  11. Patents.
+
+  A "contributor" is a copyright holder who authorizes use under this
+License of the Program or a work on which the Program is based.  The
+work thus licensed is called the contributor's "contributor version".
+
+  A contributor's "essential patent claims" are all patent claims
+owned or controlled by the contributor, whether already acquired or
+hereafter acquired, that would be infringed by some manner, permitted
+by this License, of making, using, or selling its contributor version,
+but do not include claims that would be infringed only as a
+consequence of further modification of the contributor version.  For
+purposes of this definition, "control" includes the right to grant
+patent sublicenses in a manner consistent with the requirements of
+this License.
+
+  Each contributor grants you a non-exclusive, worldwide, royalty-free
+patent license under the contributor's essential patent claims, to
+make, use, sell, offer for sale, import and otherwise run, modify and
+propagate the contents of its contributor version.
+
+  In the following three paragraphs, a "patent license" is any express
+agreement or commitment, however denominated, not to enforce a patent
+(such as an express permission to practice a patent or covenant not to
+sue for patent infringement).  To "grant" such a patent license to a
+party means to make such an agreement or commitment not to enforce a
+patent against the party.
+
+  If you convey a covered work, knowingly relying on a patent license,
+and the Corresponding Source of the work is not available for anyone
+to copy, free of charge and under the terms of this License, through a
+publicly available network server or other readily accessible means,
+then you must either (1) cause the Corresponding Source to be so
+available, or (2) arrange to deprive yourself of the benefit of the
+patent license for this particular work, or (3) arrange, in a manner
+consistent with the requirements of this License, to extend the patent
+license to downstream recipients.  "Knowingly relying" means you have
+actual knowledge that, but for the patent license, your conveying the
+covered work in a country, or your recipient's use of the covered work
+in a country, would infringe one or more identifiable patents in that
+country that you have reason to believe are valid.
+
+  If, pursuant to or in connection with a single transaction or
+arrangement, you convey, or propagate by procuring conveyance of, a
+covered work, and grant a patent license to some of the parties
+receiving the covered work authorizing them to use, propagate, modify
+or convey a specific copy of the covered work, then the patent license
+you grant is automatically extended to all recipients of the covered
+work and works based on it.
+
+  A patent license is "discriminatory" if it does not include within
+the scope of its coverage, prohibits the exercise of, or is
+conditioned on the non-exercise of one or more of the rights that are
+specifically granted under this License.  You may not convey a covered
+work if you are a party to an arrangement with a third party that is
+in the business of distributing software, under which you make payment
+to the third party based on the extent of your activity of conveying
+the work, and under which the third party grants, to any of the
+parties who would receive the covered work from you, a discriminatory
+patent license (a) in connection with copies of the covered work
+conveyed by you (or copies made from those copies), or (b) primarily
+for and in connection with specific products or compilations that
+contain the covered work, unless you entered into that arrangement,
+or that patent license was granted, prior to 28 March 2007.
+
+  Nothing in this License shall be construed as excluding or limiting
+any implied license or other defenses to infringement that may
+otherwise be available to you under applicable patent law.
+
+  12. No Surrender of Others' Freedom.
+
+  If conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot convey a
+covered work so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you may
+not convey it at all.  For example, if you agree to terms that obligate you
+to collect a royalty for further conveying from those to whom you convey
+the Program, the only way you could satisfy both those terms and this
+License would be to refrain entirely from conveying the Program.
+
+  13. Use with the GNU Affero General Public License.
+
+  Notwithstanding any other provision of this License, you have
+permission to link or combine any covered work with a work licensed
+under version 3 of the GNU Affero General Public License into a single
+combined work, and to convey the resulting work.  The terms of this
+License will continue to apply to the part which is the covered work,
+but the special requirements of the GNU Affero General Public License,
+section 13, concerning interaction through a network will apply to the
+combination as such.
+
+  14. Revised Versions of this License.
+
+  The Free Software Foundation may publish revised and/or new versions of
+the GNU General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+  Each version is given a distinguishing version number.  If the
+Program specifies that a certain numbered version of the GNU General
+Public License "or any later version" applies to it, you have the
+option of following the terms and conditions either of that numbered
+version or of any later version published by the Free Software
+Foundation.  If the Program does not specify a version number of the
+GNU General Public License, you may choose any version ever published
+by the Free Software Foundation.
+
+  If the Program specifies that a proxy can decide which future
+versions of the GNU General Public License can be used, that proxy's
+public statement of acceptance of a version permanently authorizes you
+to choose that version for the Program.
+
+  Later license versions may give you additional or different
+permissions.  However, no additional obligations are imposed on any
+author or copyright holder as a result of your choosing to follow a
+later version.
+
+  15. Disclaimer of Warranty.
+
+  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
+APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
+HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
+OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
+THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
+IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
+ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. Limitation of Liability.
+
+  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
+THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
+GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
+USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
+DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
+PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
+EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
+SUCH DAMAGES.
+
+  17. Interpretation of Sections 15 and 16.
+
+  If the disclaimer of warranty and limitation of liability provided
+above cannot be given local legal effect according to their terms,
+reviewing courts shall apply local law that most closely approximates
+an absolute waiver of all civil liability in connection with the
+Program, unless a warranty or assumption of liability accompanies a
+copy of the Program in return for a fee.
+
+                     END OF TERMS AND CONDITIONS
+
+            How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+state the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software: you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+Also add information on how to contact you by electronic and paper mail.
+
+  If the program does terminal interaction, make it output a short
+notice like this when it starts in an interactive mode:
+
+    <program>  Copyright (C) <year>  <name of author>
+    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, your program's commands
+might be different; for a GUI interface, you would use an "about box".
+
+  You should also get your employer (if you work as a programmer) or school,
+if any, to sign a "copyright disclaimer" for the program, if necessary.
+For more information on this, and how to apply and follow the GNU GPL, see
+<http://www.gnu.org/licenses/>.
+
+  The GNU General Public License does not permit incorporating your program
+into proprietary programs.  If your program is a subroutine library, you
+may consider it more useful to permit linking proprietary applications with
+the library.  If this is what you want to do, use the GNU Lesser General
+Public License instead of this License.  But first, please read
+<http://www.gnu.org/philosophy/why-not-lgpl.html>.
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/.deps/base64.Po SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/.deps/base64.Po
--- trunk/helpers/negotiate_auth/negotiate_wrapper/.deps/base64.Po	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/.deps/base64.Po	2011-03-13 22:28:15.000000000 +0000
@@ -0,0 +1,85 @@
+base64.o: base64.cc /usr/include/stdio.h /usr/include/features.h \
+ /usr/include/sys/cdefs.h /usr/include/bits/wordsize.h \
+ /usr/include/gnu/stubs.h /usr/include/gnu/stubs-32.h \
+ /usr/lib/gcc/i586-suse-linux/4.5/include/stddef.h \
+ /usr/include/bits/types.h /usr/include/bits/typesizes.h \
+ /usr/include/libio.h /usr/include/_G_config.h /usr/include/wchar.h \
+ /usr/lib/gcc/i586-suse-linux/4.5/include/stdarg.h \
+ /usr/include/bits/stdio_lim.h /usr/include/bits/sys_errlist.h \
+ /usr/include/bits/stdio.h /usr/include/stdlib.h \
+ /usr/include/bits/waitflags.h /usr/include/bits/waitstatus.h \
+ /usr/include/endian.h /usr/include/bits/endian.h \
+ /usr/include/bits/byteswap.h /usr/include/xlocale.h \
+ /usr/include/sys/types.h /usr/include/time.h /usr/include/sys/select.h \
+ /usr/include/bits/select.h /usr/include/bits/sigset.h \
+ /usr/include/bits/time.h /usr/include/sys/sysmacros.h \
+ /usr/include/bits/pthreadtypes.h /usr/include/alloca.h \
+ /usr/include/string.h base64.h
+
+/usr/include/stdio.h:
+
+/usr/include/features.h:
+
+/usr/include/sys/cdefs.h:
+
+/usr/include/bits/wordsize.h:
+
+/usr/include/gnu/stubs.h:
+
+/usr/include/gnu/stubs-32.h:
+
+/usr/lib/gcc/i586-suse-linux/4.5/include/stddef.h:
+
+/usr/include/bits/types.h:
+
+/usr/include/bits/typesizes.h:
+
+/usr/include/libio.h:
+
+/usr/include/_G_config.h:
+
+/usr/include/wchar.h:
+
+/usr/lib/gcc/i586-suse-linux/4.5/include/stdarg.h:
+
+/usr/include/bits/stdio_lim.h:
+
+/usr/include/bits/sys_errlist.h:
+
+/usr/include/bits/stdio.h:
+
+/usr/include/stdlib.h:
+
+/usr/include/bits/waitflags.h:
+
+/usr/include/bits/waitstatus.h:
+
+/usr/include/endian.h:
+
+/usr/include/bits/endian.h:
+
+/usr/include/bits/byteswap.h:
+
+/usr/include/xlocale.h:
+
+/usr/include/sys/types.h:
+
+/usr/include/time.h:
+
+/usr/include/sys/select.h:
+
+/usr/include/bits/select.h:
+
+/usr/include/bits/sigset.h:
+
+/usr/include/bits/time.h:
+
+/usr/include/sys/sysmacros.h:
+
+/usr/include/bits/pthreadtypes.h:
+
+/usr/include/alloca.h:
+
+/usr/include/string.h:
+
+base64.h:
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/.deps/negotiate_wrapper.Po SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/.deps/negotiate_wrapper.Po
--- trunk/helpers/negotiate_auth/negotiate_wrapper/.deps/negotiate_wrapper.Po	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/.deps/negotiate_wrapper.Po	2011-03-13 22:28:15.000000000 +0000
@@ -0,0 +1,357 @@
+negotiate_wrapper.o: negotiate_wrapper.cc ../../../include/config.h \
+ ../../../include/autoconf.h ../../../include/version.h \
+ ../../../compat/compat.h ../../../compat/osdetect.h \
+ ../../../compat/fdsetsize.h /usr/include/features.h \
+ /usr/include/sys/cdefs.h /usr/include/bits/wordsize.h \
+ /usr/include/gnu/stubs.h /usr/include/gnu/stubs-32.h \
+ /usr/include/bits/types.h /usr/include/bits/typesizes.h \
+ /usr/include/linux/posix_types.h /usr/include/linux/stddef.h \
+ /usr/include/asm/posix_types.h /usr/include/asm/posix_types_32.h \
+ ../../../compat/types.h /usr/include/sys/types.h /usr/include/time.h \
+ /usr/lib/gcc/i586-suse-linux/4.5/include/stddef.h /usr/include/endian.h \
+ /usr/include/bits/endian.h /usr/include/bits/byteswap.h \
+ /usr/include/sys/select.h /usr/include/bits/select.h \
+ /usr/include/bits/sigset.h /usr/include/bits/time.h \
+ /usr/include/sys/sysmacros.h /usr/include/bits/pthreadtypes.h \
+ /usr/include/linux/types.h /usr/include/asm/types.h \
+ /usr/include/asm-generic/types.h /usr/include/asm-generic/int-ll64.h \
+ /usr/include/asm/bitsperlong.h /usr/include/asm-generic/bitsperlong.h \
+ /usr/include/stdlib.h /usr/include/bits/waitflags.h \
+ /usr/include/bits/waitstatus.h /usr/include/xlocale.h \
+ /usr/include/alloca.h /usr/include/inttypes.h \
+ /usr/lib/gcc/i586-suse-linux/4.5/include/stdint.h /usr/include/stdint.h \
+ /usr/include/bits/wchar.h /usr/include/sys/bitypes.h \
+ /usr/include/netinet/in_systm.h ../../../compat/os/aix.h \
+ ../../../compat/os/dragonfly.h ../../../compat/os/freebsd.h \
+ ../../../compat/os/hpux.h ../../../compat/os/linux.h \
+ ../../../compat/os/macosx.h ../../../compat/os/mswin.h \
+ ../../../compat/os/netbsd.h ../../../compat/os/next.h \
+ ../../../compat/os/openbsd.h ../../../compat/os/os2.h \
+ ../../../compat/os/qnx.h ../../../compat/os/sgi.h \
+ ../../../compat/os/solaris.h ../../../compat/os/sunos.h \
+ ../../../compat/os/windows.h ../../../compat/compat_shared.h \
+ /usr/include/sys/time.h /usr/include/sys/resource.h \
+ /usr/include/bits/resource.h /usr/include/dirent.h \
+ /usr/include/bits/dirent.h /usr/include/bits/posix1_lim.h \
+ /usr/include/bits/local_lim.h /usr/include/linux/limits.h \
+ /usr/include/fcntl.h /usr/include/bits/fcntl.h /usr/include/bits/uio.h \
+ /usr/include/sys/stat.h /usr/include/bits/stat.h \
+ /usr/include/et/com_err.h \
+ /usr/lib/gcc/i586-suse-linux/4.5/include/stdarg.h \
+ ../../../compat/xalloc.h ../../../compat/xstrerror.h \
+ ../../../compat/xstring.h /usr/include/string.h ../../../compat/xstrto.h \
+ /usr/lib/gcc/i586-suse-linux/4.5/include/stdbool.h ../../../compat/xis.h \
+ /usr/include/ctype.h ../../../compat/stdvarargs.h /usr/include/syslog.h \
+ /usr/include/sys/syslog.h /usr/include/bits/syslog-path.h \
+ ../../../compat/assert.h ../../../compat/debug.h /usr/include/stdio.h \
+ /usr/include/libio.h /usr/include/_G_config.h /usr/include/wchar.h \
+ /usr/include/bits/stdio_lim.h /usr/include/bits/sys_errlist.h \
+ /usr/include/bits/stdio.h /usr/include/unistd.h \
+ /usr/include/bits/posix_opt.h /usr/include/bits/environments.h \
+ /usr/include/bits/confname.h /usr/include/getopt.h \
+ ../../../compat/valgrind.h /usr/local/include/valgrind/memcheck.h \
+ /usr/local/include/valgrind/valgrind.h ../../../include/squid_endian.h \
+ /usr/include/byteswap.h ../../../compat/GnuRegex.h /usr/include/regex.h \
+ ../../../compat/unsafe.h ../../../include/util.h \
+ /usr/include/arpa/inet.h /usr/include/netinet/in.h \
+ /usr/include/sys/socket.h /usr/include/sys/uio.h \
+ /usr/include/bits/socket.h /usr/include/bits/sockaddr.h \
+ /usr/include/asm/socket.h /usr/include/asm-generic/socket.h \
+ /usr/include/asm/sockios.h /usr/include/asm-generic/sockios.h \
+ /usr/include/bits/in.h ../../../include/SquidNew.h \
+ /usr/include/c++/4.5/new /usr/include/c++/4.5/cstddef \
+ /usr/include/c++/4.5/i586-suse-linux/bits/c++config.h \
+ /usr/include/c++/4.5/i586-suse-linux/bits/os_defines.h \
+ /usr/include/c++/4.5/i586-suse-linux/bits/cpu_defines.h \
+ /usr/include/c++/4.5/exception /usr/include/netdb.h \
+ /usr/include/rpc/netdb.h /usr/include/bits/siginfo.h \
+ /usr/include/bits/netdb.h /usr/include/errno.h /usr/include/bits/errno.h \
+ /usr/include/linux/errno.h /usr/include/asm/errno.h \
+ /usr/include/asm-generic/errno.h /usr/include/asm-generic/errno-base.h \
+ base64.h
+
+../../../include/config.h:
+
+../../../include/autoconf.h:
+
+../../../include/version.h:
+
+../../../compat/compat.h:
+
+../../../compat/osdetect.h:
+
+../../../compat/fdsetsize.h:
+
+/usr/include/features.h:
+
+/usr/include/sys/cdefs.h:
+
+/usr/include/bits/wordsize.h:
+
+/usr/include/gnu/stubs.h:
+
+/usr/include/gnu/stubs-32.h:
+
+/usr/include/bits/types.h:
+
+/usr/include/bits/typesizes.h:
+
+/usr/include/linux/posix_types.h:
+
+/usr/include/linux/stddef.h:
+
+/usr/include/asm/posix_types.h:
+
+/usr/include/asm/posix_types_32.h:
+
+../../../compat/types.h:
+
+/usr/include/sys/types.h:
+
+/usr/include/time.h:
+
+/usr/lib/gcc/i586-suse-linux/4.5/include/stddef.h:
+
+/usr/include/endian.h:
+
+/usr/include/bits/endian.h:
+
+/usr/include/bits/byteswap.h:
+
+/usr/include/sys/select.h:
+
+/usr/include/bits/select.h:
+
+/usr/include/bits/sigset.h:
+
+/usr/include/bits/time.h:
+
+/usr/include/sys/sysmacros.h:
+
+/usr/include/bits/pthreadtypes.h:
+
+/usr/include/linux/types.h:
+
+/usr/include/asm/types.h:
+
+/usr/include/asm-generic/types.h:
+
+/usr/include/asm-generic/int-ll64.h:
+
+/usr/include/asm/bitsperlong.h:
+
+/usr/include/asm-generic/bitsperlong.h:
+
+/usr/include/stdlib.h:
+
+/usr/include/bits/waitflags.h:
+
+/usr/include/bits/waitstatus.h:
+
+/usr/include/xlocale.h:
+
+/usr/include/alloca.h:
+
+/usr/include/inttypes.h:
+
+/usr/lib/gcc/i586-suse-linux/4.5/include/stdint.h:
+
+/usr/include/stdint.h:
+
+/usr/include/bits/wchar.h:
+
+/usr/include/sys/bitypes.h:
+
+/usr/include/netinet/in_systm.h:
+
+../../../compat/os/aix.h:
+
+../../../compat/os/dragonfly.h:
+
+../../../compat/os/freebsd.h:
+
+../../../compat/os/hpux.h:
+
+../../../compat/os/linux.h:
+
+../../../compat/os/macosx.h:
+
+../../../compat/os/mswin.h:
+
+../../../compat/os/netbsd.h:
+
+../../../compat/os/next.h:
+
+../../../compat/os/openbsd.h:
+
+../../../compat/os/os2.h:
+
+../../../compat/os/qnx.h:
+
+../../../compat/os/sgi.h:
+
+../../../compat/os/solaris.h:
+
+../../../compat/os/sunos.h:
+
+../../../compat/os/windows.h:
+
+../../../compat/compat_shared.h:
+
+/usr/include/sys/time.h:
+
+/usr/include/sys/resource.h:
+
+/usr/include/bits/resource.h:
+
+/usr/include/dirent.h:
+
+/usr/include/bits/dirent.h:
+
+/usr/include/bits/posix1_lim.h:
+
+/usr/include/bits/local_lim.h:
+
+/usr/include/linux/limits.h:
+
+/usr/include/fcntl.h:
+
+/usr/include/bits/fcntl.h:
+
+/usr/include/bits/uio.h:
+
+/usr/include/sys/stat.h:
+
+/usr/include/bits/stat.h:
+
+/usr/include/et/com_err.h:
+
+/usr/lib/gcc/i586-suse-linux/4.5/include/stdarg.h:
+
+../../../compat/xalloc.h:
+
+../../../compat/xstrerror.h:
+
+../../../compat/xstring.h:
+
+/usr/include/string.h:
+
+../../../compat/xstrto.h:
+
+/usr/lib/gcc/i586-suse-linux/4.5/include/stdbool.h:
+
+../../../compat/xis.h:
+
+/usr/include/ctype.h:
+
+../../../compat/stdvarargs.h:
+
+/usr/include/syslog.h:
+
+/usr/include/sys/syslog.h:
+
+/usr/include/bits/syslog-path.h:
+
+../../../compat/assert.h:
+
+../../../compat/debug.h:
+
+/usr/include/stdio.h:
+
+/usr/include/libio.h:
+
+/usr/include/_G_config.h:
+
+/usr/include/wchar.h:
+
+/usr/include/bits/stdio_lim.h:
+
+/usr/include/bits/sys_errlist.h:
+
+/usr/include/bits/stdio.h:
+
+/usr/include/unistd.h:
+
+/usr/include/bits/posix_opt.h:
+
+/usr/include/bits/environments.h:
+
+/usr/include/bits/confname.h:
+
+/usr/include/getopt.h:
+
+../../../compat/valgrind.h:
+
+/usr/local/include/valgrind/memcheck.h:
+
+/usr/local/include/valgrind/valgrind.h:
+
+../../../include/squid_endian.h:
+
+/usr/include/byteswap.h:
+
+../../../compat/GnuRegex.h:
+
+/usr/include/regex.h:
+
+../../../compat/unsafe.h:
+
+../../../include/util.h:
+
+/usr/include/arpa/inet.h:
+
+/usr/include/netinet/in.h:
+
+/usr/include/sys/socket.h:
+
+/usr/include/sys/uio.h:
+
+/usr/include/bits/socket.h:
+
+/usr/include/bits/sockaddr.h:
+
+/usr/include/asm/socket.h:
+
+/usr/include/asm-generic/socket.h:
+
+/usr/include/asm/sockios.h:
+
+/usr/include/asm-generic/sockios.h:
+
+/usr/include/bits/in.h:
+
+../../../include/SquidNew.h:
+
+/usr/include/c++/4.5/new:
+
+/usr/include/c++/4.5/cstddef:
+
+/usr/include/c++/4.5/i586-suse-linux/bits/c++config.h:
+
+/usr/include/c++/4.5/i586-suse-linux/bits/os_defines.h:
+
+/usr/include/c++/4.5/i586-suse-linux/bits/cpu_defines.h:
+
+/usr/include/c++/4.5/exception:
+
+/usr/include/netdb.h:
+
+/usr/include/rpc/netdb.h:
+
+/usr/include/bits/siginfo.h:
+
+/usr/include/bits/netdb.h:
+
+/usr/include/errno.h:
+
+/usr/include/bits/errno.h:
+
+/usr/include/linux/errno.h:
+
+/usr/include/asm/errno.h:
+
+/usr/include/asm-generic/errno.h:
+
+/usr/include/asm-generic/errno-base.h:
+
+base64.h:
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/Makefile.am SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/Makefile.am
--- trunk/helpers/negotiate_auth/negotiate_wrapper/Makefile.am	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/Makefile.am	2011-03-13 21:58:14.000000000 +0000
@@ -0,0 +1,16 @@
+include $(top_srcdir)/src/Common.am
+EXTRA_DIST = README COPYING 
+
+SUBDIRS = 
+
+libexec_PROGRAMS = negotiate_wrapper
+
+SOURCE = negotiate_wrapper.cc base64.cc base64.h
+
+negotiate_wrapper_SOURCES = $(SOURCE)
+AM_CPPFLAGS = $(INCLUDES) -I$(srcdir)
+
+negotiate_wrapper_LDFLAGS = 
+negotiate_wrapper_LDADD = $(COMPAT_LIB) $(XTRA_LIBS)
+
+man_MANS = negotiate_wrapper.8
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.8 SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.8
--- trunk/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.8	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.8	2011-03-13 22:07:40.000000000 +0000
@@ -0,0 +1,99 @@
+.if !'po4a'hide' .TH negotiate_wrapper 8
+.
+.SH NAME
+.if !'po4a'hide' .B negotiate_wrapper
+.if !'po4a'hide' \-
+Squid negotiate wrapper to call seperate ntlm and kerberos based authentication helper
+.PP
+Version 1.0.2sq
+.
+.SH SYNOPSIS
+.if !'po4a'hide' .B negotiate_wrapper
+.if !'po4a'hide' .B [\-h] | [\-d] \-\-ntlm ntlm-helper-path ntlm-helper-args \-\-kerberos kerberos-helper-path kerberos-helper-args
+.
+.SH DESCRIPTION
+.B negotiate_wrapper
+is an installed binary and allows Squid to authenticate users via the Negotiate 
+protocol and NTLM or Kerberos.  
+
+.SH OPTIONS
+.if !'po4a'hide' .TP 12
+.if !'po4a'hide' .B \-h
+Display the binary help and command line syntax info using stderr.
+.if !'po4a'hide' .TP 12
+.if !'po4a'hide' .B \-d
+Write debug messages to stderr.
+.if !'po4a'hide' .TP 12
+.if !'po4a'hide' .B \-\-ntlm ntlm-helper-path ntlm-helper-args
+Provide NTLM helper details
+.if !'po4a'hide' .TP 12
+.if !'po4a'hide' .B \-\-kerberos kerberos-helper-path kerberos-helper-args
+Provide Kerberos helper details
+.
+.SH CONFIGURATION
+.PP See FAQ wiki page for examples of how to write configuration snippets. (TBD)
+.PP 
+This helper is intended to be used as an
+.B authentication
+helper in
+.B squid.conf.
+.if !'po4a'hide' .P
+.if !'po4a'hide' .ft CR
+.if !'po4a'hide' .nf
+.if !'po4a'hide' auth_param negotiate program /path/to/negotiate_wrapper --ntlm /usr/bin/ntlm_auth --kerberos /usr/bin/squid_kerb_auth
+.if !'po4a'hide' .br
+.if !'po4a'hide' auth_param negotiate children 10
+.if !'po4a'hide' .br
+.if !'po4a'hide' auth_param negotiate keep_alive on
+.if !'po4a'hide' .fi
+.if !'po4a'hide' .ft
+.PP
+.B NOTE:
+None
+.
+.SH AUTHOR
+This program was written by
+.if !'po4a'hide' .I Markus Moeller <markus_moeller@compuserve.com>
+.PP
+This manual was written by
+.if !'po4a'hide' .I Markus Moeller <markus_moeller@compuserve.com>
+.
+.SH COPYRIGHT
+This program and documentation is copyright to the authors named above.
+.PP
+Distributed under the GNU General Public License (GNU GPL) version 2 or later (GPLv2+).
+.
+.SH QUESTIONS
+Questions on the usage of this program can be sent to the
+.I Squid Users mailing list
+.if !'po4a'hide' <squid-users@squid-cache.org>
+.
+.SH REPORTING BUGS
+Bug reports need to be made in English.
+See http://wiki.squid-cache.org/SquidFaq/BugReporting for details of what you need to include with your bug report.
+.PP
+Report bugs or bug fixes using http://bugs.squid-cache.org/
+.PP
+Report serious security bugs to
+.I Squid Bugs <squid-bugs@squid-cache.org>
+.PP
+Report ideas for new improvements to the
+.I Squid Developers mailing list
+.if !'po4a'hide' <squid-dev@squid-cache.org>
+.
+.SH SEE ALSO
+.if !'po4a'hide' .BR squid "(8) "
+.if !'po4a'hide' .BR ext_kerberos_ldap_group_acl "(8) "
+.br
+.BR RFC4559 " - SPNEGO-based Kerberos and NTLM HTTP Authentication in Microsoft Windows,"
+.br
+.BR RFC2478 " - The Simple and Protected GSS-API Negotiation Mechanism,"
+.br
+.BR RFC1964 " - The Kerberos Version 5 GSS-API Mechanism,"
+.br
+The Squid FAQ wiki
+.if !'po4a'hide' http://wiki.squid-cache.org/SquidFaq
+.br
+The Squid Configuration Manual
+.if !'po4a'hide' http://www.squid-cache.org/Doc/config/
+.if !'po4a'hide' http://wiki.squid-cache.org/ConfigExamples/Authenticate/Kerberos
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.cc SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.cc
--- trunk/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.cc	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/negotiate_wrapper.cc	2011-03-13 22:18:54.000000000 +0000
@@ -0,0 +1,386 @@
+/*
+ * -----------------------------------------------------------------------------
+ *
+ * Author: Markus Moeller (markus_moeller at compuserve.com)
+ *
+ * Copyright (C) 2011 Markus Moeller. All rights reserved.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 2 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
+ *
+ * -----------------------------------------------------------------------------
+ */
+/*
+ * Hosted at http://sourceforge.net/projects/squidkerbauth
+ */
+
+#include "config.h"
+#include "util.h"
+
+#if HAVE_STRING_H
+#include <string.h>
+#endif
+#if HAVE_STDIO_H
+#include <stdio.h>
+#endif
+#if HAVE_STDLIB_H
+#include <stdlib.h>
+#endif
+#if HAVE_NETDB_H
+#include <netdb.h>
+#endif
+#if HAVE_UNISTD_H
+#include <unistd.h>
+#endif
+#if HAVE_TIME_H
+#include <time.h>
+#endif
+#if HAVE_SYS_TIME_H
+#include <sys/time.h>
+#endif
+#if HAVE_ERRNO_H
+#include <errno.h>
+#endif
+
+#include "base64.h"
+
+#define PROGRAM "negotiate_wrapper"
+#define NW_VERSION "1.0.2sq"
+
+#define error(X...) \
+                     fprintf(stderr, "%s(%d): pid=%ld :", __FILE__, __LINE__, (long)getpid() ); \
+                     fprintf(stderr,X); \
+
+#ifndef MAX_AUTHTOKEN_LEN
+#define MAX_AUTHTOKEN_LEN   65535
+#endif
+
+static const unsigned char ntlmProtocol[] =
+{'N', 'T', 'L', 'M', 'S', 'S', 'P', 0};
+
+static const char *LogTime(void);
+
+static const char *
+LogTime(void)
+{
+    struct tm *tm;
+    struct timeval now;
+    static time_t last_t = 0;
+    static char buf[128];
+
+    gettimeofday(&now, NULL);
+    if (now.tv_sec != last_t) {
+	tm = localtime((time_t *) & now.tv_sec);
+	strftime(buf, 127, "%Y/%m/%d %H:%M:%S", tm);
+	last_t = now.tv_sec;
+    }
+    return buf;
+}
+void usage(void);
+
+void
+usage(void)
+{
+    fprintf(stderr, "Usage: \n");
+    fprintf(stderr, "negotiate_wrapper [-h] [-d] --ntlm ntlm helper + arguments --kerberos kerberos helper + arguments\n");
+    fprintf(stderr, "-h help\n");
+    fprintf(stderr, "-d full debug\n");
+    fprintf(stderr, "--ntlm full ntlm helper path with arguments\n");
+    fprintf(stderr, "--kerberos full kerberos helper path with arguments\n");
+}
+
+int debug_enabled = 0;
+
+int
+main(int argc, char *const argv[])
+{
+    char buf[MAX_AUTHTOKEN_LEN];
+    char tbuff[MAX_AUTHTOKEN_LEN];
+    char buff[MAX_AUTHTOKEN_LEN + 2];
+    char *c;
+    static int err = 0;
+    int length;
+    int nstart = 0, kstart = 0;
+    int nend = 0, kend = 0;
+    char *token;
+    char **nargs, **kargs;
+    int i, j;
+    int fpid;
+    FILE *FDKIN, *FDKOUT;
+    FILE *FDNIN, *FDNOUT;
+    int pkin[2];
+    int pkout[2];
+    int pnin[2];
+    int pnout[2];
+
+    setbuf(stdout, NULL);
+    setbuf(stdin, NULL);
+
+    if (argc == 1 || !strncasecmp(argv[1], "-h", 2)) {
+	usage();
+	exit(0);
+    }
+    j = 1;
+    if (!strncasecmp(argv[1], "-d", 2)) {
+	debug_enabled = 1;
+	j = 2;
+    }
+    for (i = j; i < argc; i++) {
+	if (!strncasecmp(argv[i], "--ntlm", 6))
+	    nstart = i;
+	if (!strncasecmp(argv[i], "--kerberos", 10))
+	    kstart = i;
+    }
+    if (nstart > kstart) {
+	kend = nstart - 1;
+	nend = argc - 1;
+    } else {
+	kend = argc - 1;
+	nend = kstart - 1;
+    }
+    if (nstart == 0 || kstart == 0 || kend - kstart <= 0 || nend - nstart <= 0) {
+	usage();
+	exit(0);
+    }
+    debug((char *) "%s| %s:DEBUG:  Starting version %s\n", LogTime(), PROGRAM,
+	NW_VERSION);
+
+    if ((nargs = (char **) xmalloc((nend - nstart + 1) * sizeof(char *))) == NULL) {
+	error((char *) "%s| %s: ERROR: Error allocating memory for ntlm helper\n", LogTime(), PROGRAM);
+	exit(1);
+    }
+    memcpy(nargs, argv + nstart + 1, (nend - nstart) * sizeof(char *));
+    nargs[nend - nstart] = NULL;
+    if (debug_enabled) {
+	debug((char *) "%s| %s: DEBUG: NTLM command: ", LogTime(), PROGRAM);
+	for (i = 0; i < nend - nstart; i++)
+	    debug((char *) "%s ", nargs[i]);
+	debug((char *) "\n");
+    }
+    if ((kargs = (char **) xmalloc((kend - kstart + 1) * sizeof(char *))) == NULL) {
+	error((char *) "%s| %s: ERROR: Error allocating memory for kerberos helper\n", LogTime(), PROGRAM);
+	exit(1);
+    }
+    memcpy(kargs, argv + kstart + 1, (kend - kstart) * sizeof(char *));
+    kargs[kend - kstart] = NULL;
+    if (debug_enabled) {
+	debug((char *) "%s| %s: DEBUG: Kerberos command: ", LogTime(), PROGRAM);
+	for (i = 0; i < kend - kstart; i++)
+	    debug((char *) "%s ", kargs[i]);
+	debug((char *) "\n");
+    }
+    /*
+     * Fork Kerberos helper and NTLM helper and manage IO to send NTLM requests 
+     * to the right helper. squid must keep session state 
+     */
+
+    pipe(pkin);
+    pipe(pkout);
+
+    if ((fpid = vfork()) < 0) {
+	error((char *) "%s| %s: ERROR: Failed first fork\n", LogTime(), PROGRAM);
+	exit(1);
+    }
+    if (fpid == 0) {
+	/* First Child for Kerberos helper */
+
+	close(pkin[1]);
+	dup2(pkin[0], STDIN_FILENO);
+	close(pkin[0]);
+
+	close(pkout[0]);
+	dup2(pkout[1], STDOUT_FILENO);
+	close(pkout[1]);
+
+	setbuf(stdin, NULL);
+	setbuf(stdout, NULL);
+
+	execv(kargs[0], kargs);
+	error((char *) "%s| %s: Failed execv for %s: %s\n", LogTime(), PROGRAM, kargs[0], strerror(errno));
+	exit(1);
+
+    }
+    close(pkin[0]);
+    close(pkout[1]);
+
+    pipe(pnin);
+    pipe(pnout);
+
+    if ((fpid = vfork()) < 0) {
+	error((char *) "%s| %s: Failed second fork\n", LogTime(), PROGRAM);
+	exit(1);
+    }
+    if (fpid == 0) {
+	/* Second Child for NTLM helper */
+
+	close(pnin[1]);
+	dup2(pnin[0], STDIN_FILENO);
+	close(pnin[0]);
+
+	close(pnout[0]);
+	dup2(pnout[1], STDOUT_FILENO);
+	close(pnout[1]);
+
+	setbuf(stdin, NULL);
+	setbuf(stdout, NULL);
+
+	execv(nargs[0], nargs);
+	error((char *) "%s| %s: Failed execv for %s: %s\n", LogTime(), PROGRAM, nargs[0], strerror(errno));
+	exit(1);
+
+    }
+    close(pnin[0]);
+    close(pnout[1]);
+
+    FDKIN = fdopen(pkin[1], "w");
+    FDKOUT = fdopen(pkout[0], "r");
+
+    FDNIN = fdopen(pnin[1], "w");
+    FDNOUT = fdopen(pnout[0], "r");
+
+    if (!FDKIN || !FDKOUT || !FDNIN || !FDNOUT) {
+	error((char *) "%s| %s: Could not assign streams for FDKIN/FDKOUT/FDNIN/FDNOUT %d/%d/%d/%d\n",
+	    LogTime(), PROGRAM, FDKIN ? 1 : 0, FDKOUT ? 1 : 0, FDNIN ? 1 : 0, FDNOUT ? 1 : 0);
+	exit(1);
+    }
+    setbuf(FDKIN, NULL);
+    setbuf(FDKOUT, NULL);
+    setbuf(FDNIN, NULL);
+    setbuf(FDNOUT, NULL);
+
+
+    while (1) {
+	if (fgets(buf, sizeof(buf) - 1, stdin) == NULL) {
+	    if (ferror(stdin)) {
+		error((char *) "%s| %s: ERROR: fgets() failed! dying..... errno=%d (%s)\n",
+		    LogTime(), PROGRAM, ferror(stdin),
+		    strerror(ferror(stdin)));
+
+		fprintf(stdout, "BH input error\n");
+		exit(1);	/* BIIG buffer */
+	    }
+	    fprintf(stdout, "BH input error\n");
+	    exit(0);
+	}
+	c = (char *) memchr(buf, '\n', sizeof(buf) - 1);
+	if (c) {
+	    *c = '\0';
+	    length = c - buf;
+	} else {
+	    err = 1;
+	}
+	if (err) {
+	    debug((char *) "%s| %s: DEBUG: Oversized message\n", LogTime(),
+		PROGRAM);
+	    fprintf(stdout, "BH Oversized message\n");
+	    err = 0;
+	    continue;
+	}
+	debug((char *) "%s| %s: DEBUG: Got '%s' from squid (length: %d).\n",
+	    LogTime(), PROGRAM, buf, length);
+
+	if (buf[0] == '\0') {
+	    debug((char *) "%s| %s: DEBUG: Invalid request\n", LogTime(),
+		PROGRAM);
+	    fprintf(stdout, "BH Invalid request\n");
+	    continue;
+	}
+	if (strlen(buf) < 2) {
+	    debug((char *) "%s| %s: DEBUG: Invalid request [%s]\n", LogTime(),
+		PROGRAM, buf);
+	    fprintf(stdout, "BH Invalid request\n");
+	    continue;
+	}
+	if (!strncmp(buf, "QQ", 2)) {
+	    fprintf(stdout, "BH quit command\n");
+	    exit(0);
+	}
+	if (strncmp(buf, "YR", 2) && strncmp(buf, "KK", 2)) {
+	    debug((char *) "%s| %s: DEBUG: Invalid request [%s]\n", LogTime(),
+		PROGRAM, buf);
+	    fprintf(stdout, "BH Invalid request\n");
+	    continue;
+	}
+	if (strlen(buf) <= 3) {
+	    debug((char *) "%s| %s: DEBUG: Invalid negotiate request [%s]\n",
+		LogTime(), PROGRAM, buf);
+	    fprintf(stdout, "BH Invalid negotiate request\n");
+	    continue;
+	}
+	length = nw_base64_decode_len(buf + 3);
+	debug((char *) "%s| %s: DEBUG: Decode '%s' (decoded length: %d).\n",
+	    LogTime(), PROGRAM, buf + 3, (int) length);
+
+	if ((token = (char *) xmalloc(length)) == NULL) {
+	    error((char *) "%s| %s: ERROR: Error allocating memory for token\n", LogTime(), PROGRAM);
+	    exit(1);
+	}
+	nw_base64_decode(token, buf + 3, length);
+
+	if ((length >= (int) sizeof(ntlmProtocol) + 1) &&
+	    (!memcmp(token, ntlmProtocol, sizeof ntlmProtocol))) {
+	    xfree(token);
+	    debug((char *) "%s| %s: DEBUG: received type %d NTLM token\n",
+		LogTime(), PROGRAM, (int) *((unsigned char *) token +
+		    sizeof ntlmProtocol));
+	    fprintf(FDNIN, "%s\n", buf);
+	    if (fgets(tbuff, sizeof(tbuff) - 1, FDNOUT) == NULL) {
+		if (ferror(FDNOUT)) {
+		    error((char *) "%s| %s: ERROR: fgets() failed! dying..... errno=%d (%s)\n",
+			LogTime(), PROGRAM, ferror(FDNOUT), strerror(ferror(FDNOUT)));
+		    exit(1);
+		}
+		error((char *) "%s| %s: ERROR: Error reading NTLM helper response\n",
+		    LogTime(), PROGRAM);
+		exit(0);
+	    }
+	    /* 
+	     * Need to translate NTLM reply to Negotiate reply 
+	     * AF user => AF blob user
+	     * NA reason => NA blob reason
+	     * Set blob to '='
+	     */
+	    if (strlen(tbuff) >= 3 && (!strncmp(tbuff, "AF ", 3) || !strncmp(tbuff, "NA ", 3))) {
+		int k;
+		strncpy(buff, tbuff, 3);
+		buff[3] = '=';
+		for (k = 2; i <= (int) strlen(tbuff); k++)
+		    buff[k + 2] = tbuff[k];
+	    } else {
+		strcpy(buff, tbuff);
+	    }
+	} else {
+	    xfree(token);
+	    debug((char *) "%s| %s: DEBUG: received Kerberos token\n",
+		LogTime(), PROGRAM);
+
+	    fprintf(FDKIN, "%s\n", buf);
+	    if (fgets(buff, sizeof(buff) - 1, FDKOUT) == NULL) {
+		if (ferror(FDKOUT)) {
+		    error((char *) "%s| %s: ERROR: fgets() failed! dying..... errno=%d (%s)\n",
+			LogTime(), PROGRAM, ferror(FDKOUT), strerror(ferror(FDKOUT)));
+		    exit(1);
+		}
+		error((char *) "%s| %s: ERROR: Error reading Kerberos helper response\n",
+		    LogTime(), PROGRAM);
+		exit(0);
+	    }
+	}
+	fprintf(stdout, "%s", buff);
+	debug((char *) "%s| %s: DEBUG: Return '%s'\n",
+	    LogTime(), PROGRAM, buff);
+    }
+
+    exit(1);
+}
diff -ruBEN trunk/helpers/negotiate_auth/negotiate_wrapper/README SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/README
--- trunk/helpers/negotiate_auth/negotiate_wrapper/README	1970-01-01 01:00:00.000000000 +0100
+++ SQUID_3_2/helpers/negotiate_auth/negotiate_wrapper/README	2011-03-13 18:27:11.000000000 +0000
@@ -0,0 +1,5 @@
+This is a wrapper to direct negotiate/kerberos to a kerberos only authentication helper and negotiate/ntlm to a ntlm only authentication handler. The syntax is:
+
+negotiate_wrapper [-d] --ntlm <ntlm helper + arguments> --kerberos <kerberos helper + arguments>
+-d is to print debug output
+

